import "core-js/modules/es6.regexp.to-string";
import { createStore, applyMiddleware } from "redux";
import appConfig from "_/src/app-config";
import composeReducer from "./compose-reducers";

var getMiddlewareConfig = function getMiddlewareConfig(config) {
  if (config === void 0) {
    config = {};
  }

  var middlewares = [],
      callback,
      initialState;

  if (Object.prototype.toString.call(config) === "[object Array]") {
    middlewares = config;
  } else if (typeof config === "object") {
    middlewares = config["middlewares"] || middlewares;
    callback = config["afterCreateStore"];
    initialState = config["initialState"];
  }

  return {
    middlewares: middlewares,
    callback: callback,
    initialState: initialState
  };
};

var configureStore = function configureStore(config) {
  return function (reducer) {
    var _getMiddlewareConfig = getMiddlewareConfig(config),
        middlewares = _getMiddlewareConfig.middlewares,
        callback = _getMiddlewareConfig.callback,
        initialState = _getMiddlewareConfig.initialState;

    var store = createStore(composeReducer(reducer), initialState, applyMiddleware.apply(void 0, middlewares));
    callback && callback(store);
    return store;
  };
};

export default configureStore(appConfig);